/*  The one attack range function to rule them all...
    arg0 -- starting cell id
    arg1 -- Attack range
    arg2 -- Removal Range (for archer type characters) (-1 includes the tile the character is standing on)
    arg3 -- Select Type (Which type of char to select. 1 is player, 2 is enemy, 3 is both)
*/
//Down right Up Left
{
{
    var _start, _AttackRange, _SelectType, _RemovalRange, _Faction,_ListType;
    _start = argument0;//initial tile
    _AttackRange = argument1;//attack range
    _RemovalRange = argument2;//range limit
    _Faction = argument3;//our faction
    _SelectType = argument4;//target faction
    _ListType = argument5;//base attack or AoE
    
    if(_ListType = 'Attack'){
        Cursor.NumberOfTargets = 0;
    }
    else if(_ListType = 'AoE'){
        Cursor.NumberOfAoETargets = 0;
    }

    var _priorityOpen, _listClosed, _mapDist;
    _priorityOpen = ds_priority_create();
    _listClosed = ds_list_create();
    _mapDist = ds_map_create();
    
    ds_priority_add( _priorityOpen, _start, 0 );
    ds_map_add( _mapDist, _start, 0 );
    _start.Parent = 0;
    
    if(_RemovalRange = -1){
        _start.Attackable = true;
        var ii;
        ii = instance_position(_start.x,_start.y,objGuy);
        if(ii != noone){
            if(CheckFactionTarget(_Faction,ii,_SelectType)){
                if(_ListType = 'Attack'){
                    Cursor.AttackList[Cursor.NumberOfTargets] = ii;
                    Cursor.NumberOfTargets += 1;
                }
                else if(_ListType = 'AoE'){
                    Cursor.AoEList[Cursor.NumberOfAoETargets] = ii;
                    Cursor.NumberOfAoETargets += 1;
                    //show_message("found guy");
                }
            }
        }
        else{//no unit at location, test for empty tile
            if(_SelectType = 'EmptyTile'){
                if(_ListType = 'Attack'){
                    Cursor.AttackList[Cursor.NumberOfTargets] = _start;
                    Cursor.NumberOfTargets += 1;
                }
                else if(_ListType = 'AoE'){
                    Cursor.AoEList[Cursor.NumberOfAoETargets] = _start;
                    Cursor.NumberOfAoETargets += 1;
                }
            }
        }
    }
    else{
        _start.Attackable = false;
    }
    
    while ( ds_priority_size( _priorityOpen ) )
    {
        var _current;
        _current = ds_priority_delete_min( _priorityOpen );
        ds_list_add( _listClosed, _current );
        
        var _predist;
        _predist = ds_map_find_value( _mapDist, _current );
        
        with ( _current.Down )
        {
            var _dist;
            _dist = _predist + AttackCost;
            if ( ds_list_find_index( _listClosed, id ) == -1 && AttackCost && _predist + AttackCost <= _AttackRange )
            {
                if ( ds_priority_find_priority( _priorityOpen, id ) == undefined )
                {
                    ds_priority_add( _priorityOpen, id, _dist );
                    ds_map_add( _mapDist, id, _dist );
                    Parent = _current;
                    Attackable = true;
                    var ii;
                    ii = instance_position(_current.Down.x,_current.Down.y,objGuy);
                    if(ii != noone){
                        if(CheckFactionTarget(_Faction,ii,_SelectType)){
                            if(_ListType = 'Attack'){
                                Cursor.AttackList[Cursor.NumberOfTargets] = ii;
                                Cursor.NumberOfTargets += 1;
                            }
                            else if(_ListType = 'AoE'){
                                Cursor.AoEList[Cursor.NumberOfAoETargets] = ii;
                                Cursor.NumberOfAoETargets += 1;
                            }
                        }
                    }
                    else{//no unit at location, test for empty tile
                        if(_SelectType = 'EmptyTile'){
                            if(_ListType = 'Attack'){
                                Cursor.AttackList[Cursor.NumberOfTargets] = _current.Down;
                                Cursor.NumberOfTargets += 1;
                            }
                            else if(_ListType = 'AoE'){
                                Cursor.AoEList[Cursor.NumberOfAoETargets] = _current.Down;
                                Cursor.NumberOfAoETargets += 1;
                            }
                        }
                    }
                    
                }
                else
                {
                    if ( _dist < ds_priority_find_priority( _mapDist, id ) )
                    {
                        ds_priority_change_priority( _priorityOpen, id, _dist );
                        ds_map_replace( _mapDist, id, _dist );
                        Parent = _current;
                    }
                }
            }
        }
        
        with ( _current.Right )
        {
            var _dist;
            _dist = _predist + AttackCost;
            if ( ds_list_find_index( _listClosed, id ) == -1 && AttackCost && _dist <= _AttackRange )
            {
                if ( ds_priority_find_priority( _priorityOpen, id ) == undefined )
                {
                    ds_priority_add( _priorityOpen, id, _dist );
                    ds_map_add( _mapDist, id, _dist );
                    Parent = _current;
                    Attackable = true;
                    var ii;
                    ii = instance_position(_current.Right.x,_current.Right.y,objGuy);
                    if(ii != noone){
                        if(CheckFactionTarget(_Faction,ii,_SelectType)){
                            if(_ListType = 'Attack'){
                                Cursor.AttackList[Cursor.NumberOfTargets] = ii;
                                Cursor.NumberOfTargets += 1;
                            }
                            else if(_ListType = 'AoE'){
                                Cursor.AoEList[Cursor.NumberOfAoETargets] = ii;
                                Cursor.NumberOfAoETargets += 1;
                            }
                        }
                    }
                    else{//no unit at location, test for empty tile
                        if(_SelectType = 'EmptyTile'){
                            if(_ListType = 'Attack'){
                                Cursor.AttackList[Cursor.NumberOfTargets] = _current.Right;
                                Cursor.NumberOfTargets += 1;
                            }
                            else if(_ListType = 'AoE'){
                                Cursor.AoEList[Cursor.NumberOfAoETargets] = _current.Right;
                                Cursor.NumberOfAoETargets += 1;
                            }
                        }
                    }
                }
                else
                {
                    if ( _dist < ds_priority_find_priority( _mapDist, id ) )
                    {
                        ds_priority_change_priority( _priorityOpen, id, _dist );
                        ds_map_replace( _mapDist, id, _dist );
                        Parent = _current;
                    }
                }
            }
        }

        with ( _current.Up )
        {
            var _dist;
            _dist = _predist + AttackCost;
            if ( ds_list_find_index( _listClosed, id ) == -1 && AttackCost && _dist <= _AttackRange )
            {
                if ( ds_priority_find_priority( _priorityOpen, id ) == undefined )
                {
                    ds_priority_add( _priorityOpen, id, _dist );
                    ds_map_add( _mapDist, id, _dist );
                    Parent = _current;
                    Attackable = true;
                    var ii;
                    ii = instance_position(_current.Up.x,_current.Up.y,objGuy);
                    if(ii != noone){
                        if(CheckFactionTarget(_Faction,ii,_SelectType)){
                            if(_ListType = 'Attack'){
                                Cursor.AttackList[Cursor.NumberOfTargets] = ii;
                                Cursor.NumberOfTargets += 1;
                            }
                            else if(_ListType = 'AoE'){
                                Cursor.AoEList[Cursor.NumberOfAoETargets] = ii;
                                Cursor.NumberOfAoETargets += 1;
                            }
                        }
                    }
                    else{//no unit at location, test for empty tile
                        if(_SelectType = 'EmptyTile'){
                            if(_ListType = 'Attack'){
                                Cursor.AttackList[Cursor.NumberOfTargets] = _current.Up;
                                Cursor.NumberOfTargets += 1;
                            }
                            else if(_ListType = 'AoE'){
                                Cursor.AoEList[Cursor.NumberOfAoETargets] = _current.Up;
                                Cursor.NumberOfAoETargets += 1;
                            }
                        }
                    }
                }
                else
                {
                    if ( _dist < ds_priority_find_priority( _mapDist, id ) )
                    {
                        ds_priority_change_priority( _priorityOpen, id, _dist );
                        ds_map_replace( _mapDist, id, _dist );
                        Parent = _current;
                    }
                }
            }
        }
        
        with ( _current.Left )
        {
            var _dist;
            _dist = _predist + AttackCost;
            if ( ds_list_find_index( _listClosed, id ) == -1 && AttackCost && _predist + AttackCost <= _AttackRange )
            {
                if ( ds_priority_find_priority( _priorityOpen, id ) == undefined )
                {
                    ds_priority_add( _priorityOpen, id, _dist );
                    ds_map_add( _mapDist, id, _dist );
                    Parent = _current;
                    Attackable = true;
                    var ii;
                    ii = instance_position(_current.Left.x,_current.Left.y,objGuy);
                    if(ii != noone){
                        if(CheckFactionTarget(_Faction,ii,_SelectType)){
                            if(_ListType = 'Attack'){
                                Cursor.AttackList[Cursor.NumberOfTargets] = ii;
                                Cursor.NumberOfTargets += 1;
                            }
                            else if(_ListType = 'AoE'){
                                Cursor.AoEList[Cursor.NumberOfAoETargets] = ii;
                                Cursor.NumberOfAoETargets += 1;
                            }
                        }
                    }
                    else{//no unit at location, test for empty tile
                        if(_SelectType = 'EmptyTile'){
                            if(_ListType = 'Attack'){
                                Cursor.AttackList[Cursor.NumberOfTargets] = _current.Left;
                                Cursor.NumberOfTargets += 1;
                            }
                            else if(_ListType = 'AoE'){
                                Cursor.AoEList[Cursor.NumberOfAoETargets] = _current.Left;
                                Cursor.NumberOfAoETargets += 1;
                            }
                        }
                    }
                    
                }
                else
                {
                    if ( _dist < ds_priority_find_priority( _mapDist, id ) )
                    {
                        ds_priority_change_priority( _priorityOpen, id, _dist );
                        ds_map_replace( _mapDist, id, _dist );
                        Parent = _current;
                    }
                }
            }
        }
    }
    
    
    ds_priority_destroy( _priorityOpen );
    ds_list_destroy( _listClosed );
    ds_map_destroy( _mapDist );
}

//If the character is an archer or has a limit (cant attack things next to them) remove these tiles.
{
    if((argument2 != -1)){
    var _start, _AttackRange, _RemovalRange, _SelectType, _TargetsToRemove, _Faction;
    _start = argument0;
    _RemovalRange = argument2;
    _Faction = argument3;
    _SelectType = argument4;
    _TargetsToRemove = 0;

    var _priorityOpen, _listClosed, _mapDist;
    _priorityOpen = ds_priority_create();
    _listClosed = ds_list_create();
    _mapDist = ds_map_create();
    
    ds_priority_add( _priorityOpen, _start, 0 );
    ds_map_add( _mapDist, _start, 0 );
    _start.Parent = 0;
    _start.Attackable = false;
    
    while ( ds_priority_size( _priorityOpen ) )
    {
        var _current;
        _current = ds_priority_delete_min( _priorityOpen );
        ds_list_add( _listClosed, _current );
        
        var _predist;
        _predist = ds_map_find_value( _mapDist, _current );
        with ( _current.Down )
        {
            var _dist;
            _dist = _predist + AttackCost;
            if ( ds_list_find_index( _listClosed, id ) == -1 && AttackCost && _predist + AttackCost <= _RemovalRange )
            {
                if ( ds_priority_find_priority( _priorityOpen, id ) == undefined )
                {
                    ds_priority_add( _priorityOpen, id, _dist );
                    ds_map_add( _mapDist, id, _dist );
                    Parent = _current;
                    Attackable = false;
                    var ii;
                    ii = instance_position(_current.Down.x,_current.Down.y,objGuy);
                    if(ii != noone){
                        if(CheckFactionTarget(_Faction,ii,_SelectType)){
                            _TargetsToRemove += 1;
                        }
                    }
                    else{//no unit at location, test for empty tile
                        if(_SelectType = 'EmptyTile'){
                            _TargetsToRemove += 1;
                        }
                    }
                    
                }
                else
                {
                    if ( _dist < ds_priority_find_priority( _mapDist, id ) )
                    {
                        ds_priority_change_priority( _priorityOpen, id, _dist );
                        ds_map_replace( _mapDist, id, _dist );
                        Parent = _current;
                    }
                }
            }
        }
        with ( _current.Right )
        {
            var _dist;
            _dist = _predist + AttackCost;
            if ( ds_list_find_index( _listClosed, id ) == -1 && AttackCost && _dist <= _RemovalRange )
            {
                if ( ds_priority_find_priority( _priorityOpen, id ) == undefined )
                {
                    ds_priority_add( _priorityOpen, id, _dist );
                    ds_map_add( _mapDist, id, _dist );
                    Parent = _current;
                    Attackable = false;
                    var ii;
                    ii = instance_position(_current.Right.x,_current.Right.y,objGuy);
                    if(ii != noone){
                        if(CheckFactionTarget(_Faction,ii,_SelectType)){
                            _TargetsToRemove += 1;
                        }
                    }
                    else{//no unit at location, test for empty tile
                        if(_SelectType = 'EmptyTile'){
                            _TargetsToRemove += 1;
                        }
                    }
                }
                else
                {
                    if ( _dist < ds_priority_find_priority( _mapDist, id ) )
                    {
                        ds_priority_change_priority( _priorityOpen, id, _dist );
                        ds_map_replace( _mapDist, id, _dist );
                        Parent = _current;
                    }
                }
            }
        }

        with ( _current.Up )
        {
            var _dist;
            _dist = _predist + AttackCost;
            if ( ds_list_find_index( _listClosed, id ) == -1 && AttackCost && _dist <= _RemovalRange )
            {
                if ( ds_priority_find_priority( _priorityOpen, id ) == undefined )
                {
                    ds_priority_add( _priorityOpen, id, _dist );
                    ds_map_add( _mapDist, id, _dist );
                    Parent = _current;
                    Attackable = false;
                    var ii;
                    ii = instance_position(_current.Up.x,_current.Up.y,objGuy);
                    if(ii != noone){
                        if(CheckFactionTarget(_Faction,ii,_SelectType)){
                            _TargetsToRemove += 1;
                        }
                    }
                    else{//no unit at location, test for empty tile
                        if(_SelectType = 'EmptyTile'){
                            _TargetsToRemove += 1;
                        }
                    }
                }
                else
                {
                    if ( _dist < ds_priority_find_priority( _mapDist, id ) )
                    {
                        ds_priority_change_priority( _priorityOpen, id, _dist );
                        ds_map_replace( _mapDist, id, _dist );
                        Parent = _current;
                    }
                }
            }
        }
        
        with ( _current.Left )
        {
            var _dist;
            _dist = _predist + AttackCost;
            if ( ds_list_find_index( _listClosed, id ) == -1 && AttackCost && _predist + AttackCost <= _RemovalRange )
            {
                if ( ds_priority_find_priority( _priorityOpen, id ) == undefined )
                {
                    ds_priority_add( _priorityOpen, id, _dist );
                    ds_map_add( _mapDist, id, _dist );
                    Parent = _current;
                    Attackable = false;
                    var ii;
                    ii = instance_position(_current.Left.x,_current.Left.y,objGuy);
                    if(ii != noone){
                        if(CheckFactionTarget(_Faction,ii,_SelectType)){
                            _TargetsToRemove += 1;
                        }
                    }
                    else{//no unit at location, test for empty tile
                        if(_SelectType = 'EmptyTile'){
                            _TargetsToRemove += 1;
                        }
                    }
                    
                }
                else
                {
                    if ( _dist < ds_priority_find_priority( _mapDist, id ) )
                    {
                        ds_priority_change_priority( _priorityOpen, id, _dist );
                        ds_map_replace( _mapDist, id, _dist );
                        Parent = _current;
                    }
                }
            }
        }
    }
    
    
    ds_priority_destroy( _priorityOpen );
    ds_list_destroy( _listClosed );
    ds_map_destroy( _mapDist );
    //Shift array down
    var index, newindex;
    index = 0;
    newindex = _TargetsToRemove;
    
    if(_ListType = 'Attack'){
        if((Cursor.NumberOfTargets != 0)&&(_TargetsToRemove != 0)){
            while(index < Cursor.NumberOfTargets){
                if(newindex >= Cursor.NumberOfTargets){
                    Cursor.AttackList[index] = 0;
                }
                else{
                    Cursor.AttackList[index] = Cursor.AttackList[newindex];
                }
                index +=1;
                newindex +=1;
            }
            Cursor.NumberOfTargets -= _TargetsToRemove;
            if(Cursor.NumberOfTargets < 0){//In case something wierd happens, prevent future problems.
                Cursor.NumberOfTargets = 0;
            }
        }
    }
    else if(_ListType = 'AoE'){
        if((Cursor.NumberOfAoETargets != 0)&&(_TargetsToRemove != 0)){
            while(index < Cursor.NumberOfAoETargets){
                if(newindex >= Cursor.NumberOfAoETargets){
                    Cursor.AoEList[index] = 0;
                }
                else{
                    Cursor.AoEList[index] = Cursor.AoEList[newindex];
                }
                index +=1;
                newindex +=1;
            }
            Cursor.NumberOfAoETargets -= _TargetsToRemove;
            if(Cursor.NumberOfAoETargets < 0){//In case something wierd happens, prevent future problems.
                Cursor.NumberOfAoETargets = 0;
            }
        }
    }
}
}
}

