/*
with cells
if reachable
find attack range
loop through cursor list and check for character with the highest priority
set new highest (store tile)


return the tile to pathfind to

*/

var Character, MaxThreat, Tile, ThreatType, AIDone;
Character = argument0;//Guy doing the attacking
ThreatType = argument1;//which threat function to look at
AIDone = argument2;//are we already performing an action? if so, this script does nothing
MaxThreat = 0;
Tile = noone;

if(!AIDone){//if we didnt already trigger an AI task
    with(objCell){
        if(Reachable){
            //find attack range
            if((instance_position(x,y,objGuy) = noone)||((x = round(Character.x))&&(y = round(Character.y)))){//If the tile is empty or if occupied by current character
                if(Character.IsConfused){
                    FindAttackRange(self.id, Get_Battle_Stat_Total(Character,'AttackRange'), Get_Battle_Stat_Total(Character,'AttackLimit'), Character.Faction,'Confused','Attack');
                }
                else{
                    FindAttackRange(self.id, Get_Battle_Stat_Total(Character,'AttackRange'), Get_Battle_Stat_Total(Character,'AttackLimit'), Character.Faction,'Enemies','Attack');
                }
                if(Cursor.NumberOfTargets > 0){
                    //loop through targets and figure out which is the best target
                    var Index, Threat;
                    Index = 0;
                    while(Index < Cursor.NumberOfTargets){
                        Threat = CalculateThreat(Character,self.id,instance_position(Cursor.AttackList[Index].x,Cursor.AttackList[Index].y,objCell));
                        if(Threat > MaxThreat){
                            MaxThreat = Threat;
                            Tile = self.id;
                        }
                        Index += 1;
                    }
                }
            }
        }
    }
    if(Tile != noone){//We can attack this turn if there is a target
        Character.CurrentTarget = Tile;
        Character.Action = 'Attack';
        AI_MoveToPoint(Character, Tile);
        return true;//AI Successful
    }
    else{
        return false;//AI failed (no targets in range)
    }
}
return true;//AI was already done

