//Returns the selected stat of an item.
//Argument0 = Item ID
//Argument1 = What stat to return.

/*(You can always add more of these)
1 = Sprite
2 = Name1
3 = MenuName
4 = Attack
5 = Defense
6 = Agility
7 = MoveRange
8 = AttackRange
9 = 
10 = 
11 = Turns
12 = UseRange (When using the item, what is it's range)
13 = UseLimit (When using an item, what is the limitation? (like archer range) -1 means allow selecting of current tile)
14 = UseType (what type of character's to select. (allies, enemies, or both) (1,2,3)
15 = Attack Area.
16 = UseEffect
*/

var ID, Stat, CharacterID;
var Sprite, Name, MenuName, Attack, Defense, Agility, MoveRange, AttackRange, Turns, AttackArea, AttackLimit, EffectLevel;
var UseRange, UseRangeLimit, UseTarget, Effect, UseInBattle, UseInTown, TargetOther, Consumable, DoubleChance, ProjectileExplosionType;
var CritChance, MagicCritChance, CounterChance, BlockChance, PoisonChance, PoisonResistance, BattleSprite, ProjectileSprite,ProjectilePanSpeed;
var SleepChance, SleepResistance, SilenceChance, SilenceResistance;
var FireDamage, IceDamage, WindDamage, EarthDamage, LightningDamage, LightDamage, DarknessDamage, VoidDamage;
var FireResistance, IceResistance, WindResistance, EarthResistance, LightningResistance, LightResistance, DarknessResistance;
var MagicRegeneration, HealthRegeneration, HitChance, MovementType, KeyItem, PoisonPotency;
var CurseDamage, CurseDamageChance, CurseLoseTurn, IsCursed, CurseLoseTurnChance, MuddleChance, MuddleResistance, MuddlePotency;
var BuyValue, Equippable, RareItem, Damaged, ParentItem, DamageItem,DropInBattle;// SellValue;

ID = argument0;
Stat = argument1;

//This is the default attributes list
//This way you only have to add a variable
//to an item only if said item is different
//than the blank default item.
Sprite = BlankItemSlotSprite;
BattleSprite = BlankSprite;
Name = '';//the normal name printed for messages
MenuName = '';//the display name for character pages and menus (i didnt feel like making a line break function)
Attack = 0;
Defense = 0;
Agility = 0;
MoveRange = 0;
AttackRange = 0;
Turns = 0;
UseRange = 0;
UseRangeLimit = 0;
UseTarget = 'Allies';
AttackArea = 0;//AOE size increase
AttackLimit = 0;
Effect = 'none';//does it have an effect?
EffectLevel = 1;//So items can easily invoke spells. Ie, blaze level 3
UseInBattle = false;//can we use it in battle? 
UseInTown = false;//can we use it in town? (stat boosts, but not medical herbs, ect)
TargetOther = false;//town use only, do we get to choose a target? (stat boosts, ect)
Consumable = false;//Destroyed on use?
CritChance = 0;
MagicCritChance = 0;
CounterChance = 0;
DoubleChance = 0;
BlockChance = 0;
PoisonChance = 0;
PoisonResistance = 0;
PoisonPotency = 0;
SleepChance = 0;
SleepResistance = 0;
ProjectileSprite = BlankSprite;
ProjectilePanSpeed = 30;
ProjectileExplosionType = 'none';
SilenceChance = 0;
SilenceResistance = 0;
MuddleChance = 0;
MuddleResistance = 0;
MuddlePotency = 0;

FireDamage = 0;
IceDamage = 0;
WindDamage = 0;
EarthDamage = 0;
LightningDamage = 0;
LightDamage = 0;
DarknessDamage = 0;
VoidDamage = 0;

FireResistance = 0;
IceResistance = 0;
WindResistance = 0;
EarthResistance = 0;
LightningResistance = 0;
LightResistance = 0;
DarknessResistance = 0;

MagicRegeneration = 0;
HealthRegeneration = 0;
HitChance = 0;//increase attack accuracy?
MovementType = 'none';
KeyItem = false;
//End default stats list

CurseDamage = 0;
CurseLoseTurn = false;
CurseLoseTurnChance = 0;
IsCursed = false;
CurseDamageChance = 0;
BuyValue = 0;
Equippable = false;//tells shops to bypass the 'do you want to equip' flag
RareItem = false;

ParentItem = 0;//which item does it turn into when we repair it?
DamageItem = 0;//which item does it turn into when we damage it?
Damaged = false;
DropInBattle = false;
//SellValue = 0;

switch(ID){

case 1://Battered Sword
    Sprite = Item_01Sprite;
    BattleSprite = BatteredSwordSprite;
    Name = 'Battered Sword';
    MenuName = 'Battered# Sword';
    Attack = 3;
    BuyValue = 100;
    Equippable = true;
    KeyItem = true;
    break;

case 2://Battered Arrow
    Sprite = Item_02Sprite;
    Name = 'Battered Arrow';
    MenuName = 'Battered# Arrow';
    Attack = 3;
    AttackRange = 1;
    ProjectileSprite = BatteredArrowSprite;
    BuyValue = 100;
    Equippable = true;
    break;

case 3://Wooden Staff
    Sprite = Item_03Sprite;
    BattleSprite = WoodenStaffSprite;
    Name = "Wooden Staff";
    MenuName = 'Wooden# Staff';
    Attack = 3;
    //IsCursed = true;
    //CurseLoseTurn = true;
    //CurseLoseTurnChance = .25;
    //CurseDamage = 100;
    //CurseDamageChance = 1;
    BuyValue = 100;
    Equippable = true;
    break;

case 4://Power Potion
    Sprite = Item_04Sprite;
    Name = 'Power Potion';
    MenuName = 'Power# Potion';
    Effect = 'Attack Up';
    UseRange = 1;
    UseRangeLimit = -1;
    UseTarget = 'Allies';
    EffectLevel = 1;
    UseInBattle = true;
    UseInTown = true;
    TargetOther = true;
    Consumable = true;
    BuyValue = 1000;
    DropInBattle = true;
    break;

case 5://Battered knife
    Sprite = Item_06Sprite;
    Name = 'Battered Knife';
    MenuName = 'Battered# Knife';
    Attack = 4;
    AttackRange = 1;
    BattleSprite = BatteredKnifeSprite;
    ProjectileSprite = BatteredKnifeSprite;
    ProjectilePanSpeed = 15;
    BuyValue = 100;
    Equippable = true;
    break;

case 7://wooden lance
    Sprite = Item_07Sprite;
    BattleSprite = WoodenLanceSprite;
    Name = 'Wooden Lance';
    MenuName = 'Wooden# Lance';
    Attack = 4;
    BuyValue = 100;
    Equippable = true;
    break;
    
case 8://raw meat
    Sprite = Item_08Sprite;
    Name = 'Raw Meat';
    MenuName = 'Raw# Meat';
    BuyValue = 2400;
    RareItem = true;
    break;
    
case 9://renewal gem
    Sprite = Item_09Sprite;
    Name = 'Renewal Gem';
    MenuName = 'Renewal# Gem';
    BuyValue = 6000;
    break;
    
case 10://ring of renewal
    Sprite = Item_10Sprite;
    Name = 'Ring of Renewal';
    MenuName = 'Ring of# Renewal';
    BuyValue = 8000;
    Equippable = true;
    break;
    
case 11://toxic ring
    Sprite = Item_11Sprite;
    Name = 'Toxic Ring';
    MenuName = 'Toxic# Ring';
    PoisonChance = 1;
    BuyValue = 13000;
    Equippable = true;
    break;
    
case 12://old rope
    Sprite = Item_12Sprite;
    Name = 'Old Rope';
    MenuName = 'Old# Rope';
    UseInTown = true;
    BuyValue = 1000;
    RareItem = true;
    break;
    
case 13://carving knife
    Sprite = Item_13Sprite;
    Name = 'Carving Knife';
    MenuName = 'Carving# Knife';
    Attack = 5;
    BattleSprite = BatteredKnifeSprite;
    BuyValue = 140;
    Equippable = true;
    RareItem = true;
    break;
    
case 14://medical herb
    Sprite = Item_14Sprite;
    Name = 'Medical Herb';
    MenuName = 'Medical# Herb';
    UseRange = 1;
    UseRangeLimit = -1;
    UseTarget = 'Allies';
    UseInBattle = true;
    UseInTown = false;
    Consumable = true;
    Effect = 'Minor Heal';
    EffectLevel = 1;
    BuyValue = 10;
    break;
    
case 15://shining ball
    Sprite = Item_15Sprite;
    Name = 'Shining Ball';
    MenuName = 'Shining# Ball';
    UseRange = 2;
    UseRangeLimit = 0;
    UseTarget = 'Enemies';
    UseInBattle = true;
    UseInTown = false;
    Consumable = true;
    Effect = 'Blaze';
    EffectLevel = 3;
    BuyValue = 1500;
    break;
    
case 16://blizzard
    Sprite = Item_16Sprite;
    Name = 'Blizzard';
    MenuName = 'Blizzard';
    UseRange = 2;
    UseRangeLimit = 0;
    UseTarget = 'Enemies';
    UseInBattle = true;
    UseInTown = false;
    Consumable = true;
    Effect = 'Freeze';
    EffectLevel = 3;
    BuyValue = 1700;
    break;
    
case 17://holy thunder
    Sprite = Item_17Sprite;
    Name = 'Holy Thunder';
    MenuName = 'Holy# Thunder';
    UseRange = 3;
    UseRangeLimit = 0;
    UseTarget = 'Enemies';
    UseInBattle = true;
    UseInTown = false;
    Consumable = true;
    Effect = 'Bolt';
    EffectLevel = 3;
    BuyValue = 1900;
    break;
    
case 18://healing seed
    Sprite = Item_18Sprite;
    Name = 'Healing Seed';
    MenuName = 'Healing# Seed';
    UseRange = 1;
    UseRangeLimit = -1;
    UseTarget = 'Allies';
    UseInBattle = true;
    UseInTown = false;
    Consumable = true;
    Effect = 'Middle Heal';
    EffectLevel = 1;
    BuyValue = 20;
    break;
    
case 19://healing drop
    Sprite = Item_19Sprite;
    Name = 'Healing Drop';
    MenuName = 'Healing# Drop';
    UseRange = 1;
    UseRangeLimit = -1;
    UseTarget = 'Allies';
    UseInBattle = true;
    UseInTown = false;
    Consumable = true;
    Effect = 'Major Heal';
    EffectLevel = 1;
    BuyValue = 40;
    break;
    
case 20://antidote
    Sprite = Item_20Sprite;
    Name = 'Antidote';
    MenuName = 'Antidote';
    UseRange = 1;
    UseRangeLimit = -1;
    UseTarget = 'Allies';
    UseInBattle = true;
    UseInTown = true;
    TargetOther = true;
    Consumable = true;
    Effect = 'Detox';
    EffectLevel = 1;
    BuyValue = 20;
    break;
    
case 21://angel wing
    Sprite = Item_21Sprite;
    Name = 'Angel Wing';
    MenuName = 'Angel# Wing';
    UseRange = -1;
    UseRangeLimit = -1;
    UseTarget = 'Allies';
    UseInBattle = true;
    UseInTown = false;
    Consumable = true;
    Effect = 'Escape';
    EffectLevel = 1;
    BuyValue = 40;
    break;
    
case 22://fairy powder
    Sprite = Item_22Sprite;
    Name = 'Fairy Powder';
    MenuName = 'Fairy# Powder';
    UseRange = 1;
    UseRangeLimit = -1;
    UseTarget = 'Allies';
    UseInBattle = true;
    UseInTown = true;
    TargetOther = true;
    Consumable = true;
    Effect = 'Detox';
    EffectLevel = 3;
    BuyValue = 300;
    break;
    
case 23://healing water
    Sprite = Item_23Sprite;
    Name = 'Healing Water';
    MenuName = 'Healing# Water';
    UseRange = 1;
    UseRangeLimit = -1;
    UseTarget = 'Allies';
    UseInBattle = true;
    UseInTown = false;
    Consumable = true;
    Effect = 'Heal';
    EffectLevel = 4;
    BuyValue = 400;
    break;
    
case 24://fairy tear
    Sprite = Item_24Sprite;
    Name = 'Fairy Tear';
    MenuName = 'Fairy# Tear';
    UseRange = 1;
    UseRangeLimit = -1;
    UseTarget = 'Allies';
    UseInBattle = true;
    UseInTown = false;
    Consumable = true;
    Effect = 'Mana Restore';
    EffectLevel = 1;
    BuyValue = 600;
    break;
    
case 25://light of hope
    Sprite = Item_25Sprite;
    Name = 'Light of Hope';
    MenuName = 'Light of# Hope';
    UseRange = -1;
    UseRangeLimit = -1;
    UseTarget = 'Allies';
    UseInBattle = true;
    UseInTown = false;
    Consumable = true;
    Effect = 'Mana Restore';
    EffectLevel = 4;
    BuyValue = 8500;
    break;
    
case 26://healing rain
    Sprite = Item_26Sprite;
    Name = 'Healing Rain';
    MenuName = 'Healing# Rain';
    UseRange = -1;
    UseRangeLimit = -1;
    UseTarget = 'Allies';
    UseInBattle = true;
    UseInTown = false;
    Consumable = true;
    Effect = 'Aura';
    EffectLevel = 4;
    BuyValue = 8500;
    break;
    
case 27://Summon Test
    Sprite = Item_09Sprite;
    Name = 'Summon Gem';
    MenuName = 'Summon# Gem';
    UseRange = 1;
    //UseRangeLimit = -1;
    UseTarget = 'EmptyTile';
    UseInBattle = true;
    UseInTown = false;
    Consumable = false;
    Effect = 'Summon';
    EffectLevel = 1;
    BuyValue = 20000;
    break;

    
//=============
//Cheaty Stuff=
//============= 
case 100://cheater's sword
    Sprite = Item_01Sprite;
    Name = 'Cheaters Sword';
    MenuName = 'Cheaters# Sword';
    Attack = 3;
    AttackArea = 1;
    BuyValue = 10000;
    Equippable = true;
    break;
    
case 101://cheater's arrow
    Sprite = Item_02Sprite;
    Name = 'Cheaters Arrow';
    MenuName = 'Cheaters# Arrow';
    Attack = 3;
    AttackRange = 1;
    AttackArea = 1;
    BuyValue = 10000;
    Equippable = true;
    break;
    
case 102://ring of cheats
    Sprite = Item_10Sprite;
    Name = 'Ring of Cheats';
    MenuName = 'Ring of# Cheats';
    AttackArea = 1;
    BuyValue = 30000;
    Equippable = true;
    break;
}


//Return stat
switch(Stat){
    case 'Sprite': return Sprite; break;
    case 'Name': return Name; break;
    case 'MenuName': return MenuName; break;
    case 'Attack': return Attack; break;
    case 'Defense': return Defense; break;
    case 'Agility': return Agility; break;
    case 'MoveRange': return MoveRange; break;
    case 'AttackRange': return AttackRange; break;
    case 'AttackLimit': return AttackLimit; break;
    case 'Turns': return Turns; break;
    case 'UseRange': return UseRange; break;
    case 'UseRangeLimit': return UseRangeLimit; break;
    case 'UseTarget': return UseTarget; break;
    case 'AttackArea': return AttackArea; break;
    case 'Effect': return Effect; break;
    case 'UseInBattle': return UseInBattle; break;
    case 'UseInTown': return UseInTown; break;
    case 'TargetOther': return TargetOther; break;
    case 'Consumable': return Consumable; break;
    case 'DoubleChance': return DoubleChance; break;
    case 'CritChance': return CritChance; break;
    case 'MagicCritChance': return MagicCritChance; break;
    case 'CounterChance': return CounterChance; break;
    case 'BlockChance': return BlockChance; break;
    case 'PoisonChance': return PoisonChance; break;
    case 'PoisonResistance': return PoisonResistance; break;
    case 'PoisonPotency': return PoisonPotency; break;
    case 'BattleSprite': return BattleSprite; break;
    case 'ProjectileSprite': return ProjectileSprite; break;
    case 'ProjectilePanSpeed': return ProjectilePanSpeed; break;
    case 'ProjectileExplosionType': return ProjectileExplosionType; break;
    case 'EffectLevel': return EffectLevel; break;
    case 'SleepChance': return SleepChance; break;
    case 'SleepResistance': return SleepResistance; break;
    case 'SilenceChance': return SleepChance; break;
    case 'SilenceResistance': return SleepResistance; break;
    case 'FireDamage': return FireDamage; break;
    case 'IceDamage': return IceDamage; break;
    case 'WindDamage': return WindDamage; break;
    case 'EarthDamage': return EarthDamage; break;
    case 'LightningDamage': return LightningDamage; break;
    case 'LightDamage': return LightDamage; break;
    case 'DarknessDamage': return DarknessDamage; break;
    case 'FireResistance': return FireResistance; break;
    case 'IceResistance': return IceResistance; break;
    case 'WindResistance': return WindResistance; break;
    case 'EarthResistance': return EarthResistance; break;
    case 'LightningResistance': return LightningResistance; break;
    case 'LightResistance': return LightResistance; break;
    case 'DarknessResistance': return DarknessResistance; break;
    case 'MagicRegeneration': return MagicRegeneration; break;
    case 'HealthRegeneration': return HealthRegeneration; break;
    case 'VoidDamage': return VoidDamage; break;
    case 'HitChance': return HitChance; break;
    case 'MovementType': return MovementType; break;
    case 'KeyItem': return KeyItem; break;
    
    case 'MuddleChance': return MuddleChance; break;
    case 'MuddleResistance': return MuddleResistance; break;
    case 'MuddlePotency': return MuddlePotency; break;
    
    case 'CurseDamage': return CurseDamage; break;
    case 'CurseDamageChance': return CurseDamageChance; break;
    case 'CurseLoseTurn': return CurseLoseTurn; break;
    case 'CurseLoseTurnChance': return CurseLoseTurnChance; break;
    case 'IsCursed': return IsCursed; break;
    
    case 'BuyValue': return BuyValue; break;
    case 'Equippable': return Equippable; break;
    case 'RareItem': return RareItem; break;
    //case 'SellValue': return SellValue; break;
    case 'Damaged': return Damaged; break;
    case 'ParentItem': return ParentItem; break;
    case 'DamageItem': return DamageItem; break;
    case 'DropInBattle': return DropInBattle; break;
    

    
    default: return 0;
}
