//argument 0 = Spell Name
//argument 1 = Spell Level
//Argument 2 = Stat to return;


var Spell, Level, Range, Sprite, Area, ManaCost, RangeLimit, Target, SpellType, TintColor, FlashColor, Return, CurePoison, ManaRestore, TargetAllAllies, TargetAllEnemies, TargetAllUnits, SpellAIType;
var SleepChance, SilenceChance, PoisonChance, AttackBuffStrength, DefenseBuffStrength, AgilityBuffStrength, AttackDebuffStrength, DefenseDebuffStrength, AgilityDebuffStrength;
var HealDamage, FireDamage, IceDamage, WindDamage, EarthDamage, LightningDamage, LightDamage, DarknessDamage, VoidDamage, SelectType, PoisonPotency, Uncurse, Shield;
var HitChanceDebuffStrength, Confusion, MuddleChance, TargetOther;

Spell = argument0;
Level = argument1;
Return = argument2;

//Defaults
Sprite = BlankSpellSlotSprite;
//HealDamage = 0;
Range = 0;
RangeLimit = -1;
Area = 1;
ManaCost = 1;
Target = 'Allies';
SelectType = 'Allies';
CurePoison = false;
TintColor = make_color_rgb(255,255,255);//default to white (no tint)
FlashColor = make_color_rgb(0,0,0);//default to black (no flash)
ManaRestore = 0;//this spell restores 0 mana
TargetAllAllies = false;
TargetAllEnemies = false;
TargetAllUnits = false;
SpellAIType = 'DamageMagic';//For AI related stuff. Either 'DamageMagic' or 'HealMagic'
SleepChance = 0;
SilenceChance = 0;
SpellType = 'Damage';
PoisonChance = 0;
PoisonPotency = 0;
AttackBuffStrength = 0;
DefenseBuffStrength = 0;
AgilityBuffStrength = 0;
HitChanceDebuffStrength = 0;
MuddleChance = 0;
TargetOther = false;//For in town use

Confusion = false;

HealDamage = 0;
FireDamage = 0;
IceDamage = 0;
WindDamage = 0;
EarthDamage = 0;
LightningDamage = 0;
LightDamage = 0;
DarknessDamage = 0;
VoidDamage = 0;

AttackDebuffStrength = 0;
DefenseDebuffStrength = 0;
AgilityDebuffStrength = 0;
Uncurse = 0;
Shield = 0;



switch(Spell){
//=======
//=Blaze=
//=======
case 'Blaze':
    Sprite = BlazeIconSprite;
    Target = 'Enemies';
    SelectType = 'Enemies';
    RangeLimit = 0;
    SpellType = 'Damage';
    TintColor = make_color_rgb(255,102,102);
    FlashColor = make_color_rgb(255,0,0);
    SpellAIType = 'DamageMagic';
    
    switch(Level){
    case 1:
        FireDamage = 6;
        Range = 2;
        Area = 1;
        ManaCost = 2;
    break;
    case 2:
        FireDamage = 10;
        Range = 2;
        Area = 2;
        ManaCost = 6;
    break;
    case 3:
        FireDamage = 15;
        Range = 2;
        Area = 2;
        ManaCost = 10;
    break;
    case 4:
        FireDamage = 40;
        Range = 2;
        Area = 1;
        ManaCost = 10;
    break;
    }
break;
//========
//=Freeze=
//========
case 'Freeze':
    SpellType = 'Damage';
    Sprite = FreezeIconSprite;
    RangeLimit = 0;
    Target = 'Enemies';
    SelectType = 'Enemies';
    FlashColor = make_color_rgb(181,219,255);//may not be accurate
    TintColor = make_color_rgb(181,232,255);
    SpellAIType = 'DamageMagic';
    
    switch(Level){
    case 1:
        IceDamage = 10;
        Range = 2;
        Area = 1;
        ManaCost = 3;
    break;
    case 2:
        IceDamage = 12;
        Range = 2;
        Area = 2;
        ManaCost = 7;
    break;
    case 3:
        IceDamage = 18;
        Range = 3;
        Area = 2;
        ManaCost = 12;
    break;
    case 4:
        IceDamage = 50;
        Range = 3;
        Area = 1;
        ManaCost = 12;
    break;
    }
break;
//======
//=Bolt=
//======
case 'Bolt':
    Sprite = BoltIconSprite;
    RangeLimit = 0;
    Target = 'Enemies';
    SelectType = 'Enemies';
    SpellType = 'Damage';
    FlashColor = make_color_rgb(181,219,255);
    SpellAIType = 'DamageMagic';
    
    switch(Level){
    case 1:
        LightningDamage = 14;
        Range = 2;
        Area = 2;
        ManaCost = 8;
    break;
    case 2:
        LightningDamage = 16;
        Range = 3;
        Area = 3;
        ManaCost = 15;
    break;
    case 3:
        LightningDamage = 25;
        Range = 3;
        Area = 3;
        ManaCost = 20;
    break;
    case 4:
        LightningDamage = 60;
        Range = 3;
        Area = 1;
        ManaCost = 20;
    break;
    }
break;
//======
//=Heal=
//======
case 'Heal':
    Sprite = HealIconSprite;
    RangeLimit = -1;
    Target = 'Allies';
    SelectType = 'Allies';
    SpellType = 'Heal';
    FlashColor = make_color_rgb(222,182,222);
    SpellAIType = 'HealMagic';
    
    switch(Level){
    case 1:
        HealDamage = 15;
        Range = 1;
        Area = 1;
        ManaCost = 3;
    break;
    case 2:
        HealDamage = 15;
        Range = 2;
        Area = 1;
        ManaCost = 5;
    break;
    case 3:
        HealDamage = 30;
        Range = 3;
        Area = 1;
        ManaCost = 10;
    break;
    case 4:
        HealDamage = 1000;
        Range = 1;
        Area = 1;
        ManaCost = 20;
    break;
    }
break;
//======
//=Aura=
//======
case 'Aura':
    SpellType = 'Heal';
    Sprite = AuraIconSprite;
    RangeLimit = -1;
    Target = 'Allies';
    SelectType = 'Allies';
    FlashColor = make_color_rgb(222,182,222);
    SpellAIType = 'HealMagic';
    
    switch(Level){
    case 1:
        HealDamage = 15;
        Range = 2;
        Area = 2;
        ManaCost = 7;
    break;
    case 2:
        HealDamage = 15;
        Range = 3;
        Area = 3;
        ManaCost = 11;
    break;
    case 3:
        HealDamage = 30;
        Range = 3;
        Area = 3;
        ManaCost = 15;
    break;
    case 4:
        TargetAllAllies = true;
        HealDamage = 999;
        Range = 0;
        Area = 1;
        ManaCost = 20;
    break;
    }
break;
//=======
//=Sleep=
//=======
case 'Sleep':
    Sprite = SleepIconSprite;
    Target = 'Enemies';
    SelectType = 'Enemies';
    RangeLimit = 0;
    SpellType = 'StatusEffect';
    TintColor = make_color_rgb(255,102,102);
    FlashColor = make_color_rgb(255,0,0);
    SpellAIType = 'StatusEffectMagic';
    
    switch(Level){
    case 1:
        //Damage = 0;
        Range = 2;
        Area = 1;
        ManaCost = 4;
        SleepChance = 1;
    break;
    }
break;
//========
//=Dispel=
//========
case 'Dispel':
    Sprite = DispellIconSprite;
    Target = 'Enemies';
    SelectType = 'Enemies';
    RangeLimit = 0;
    SpellType = 'StatusEffect';
    TintColor = make_color_rgb(255,102,102);
    FlashColor = make_color_rgb(255,0,0);
    SpellAIType = 'StatusEffectMagic';
    
    switch(Level){
    case 1:
        //Damage = 0;
        Range = 2;
        Area = 2;
        ManaCost = 5;
        SilenceChance = 1;
    break;
    }
break;
//========
//=Attack=
//========
case 'Attack':
    Sprite = AttackIconSprite;
    Target = 'Allies';
    SelectType = 'Allies';
    RangeLimit = -1;
    SpellType = 'StatusEffect';
    TintColor = make_color_rgb(255,102,102);
    FlashColor = make_color_rgb(255,0,0);
    SpellAIType = 'StatusEffectMagic';
    
    switch(Level){
    case 1:
        Range = 3;
        Area = 1;
        ManaCost = 7;
        AttackBuffStrength = 3;
    break;
    }
break;
//=======
//=Boost=
//=======
case 'Boost':
    Sprite = BoostIconSprite;
    Target = 'Allies';
    SelectType = 'Allies';
    RangeLimit = -1;
    SpellType = 'StatusEffect';
    TintColor = make_color_rgb(255,102,102);
    FlashColor = make_color_rgb(255,0,0);
    SpellAIType = 'StatusEffectMagic';
    
    switch(Level){
    case 1:
        //Damage = 0;
        Range = 2;
        Area = 2;
        ManaCost = 2;
        DefenseBuffStrength = 3;
        AgilityBuffStrength = 3;
    break;
    case 2:
        //Damage = 0;
        Range = 3;
        Area = 3;
        ManaCost = 5;
        DefenseBuffStrength = 3;
        AgilityBuffStrength = 3;
    break;
    }
break;
//======
//=Slow=
//======
case 'Slow':
    Sprite = SlowIconSprite;
    Target = 'Enemies';
    SelectType = 'Enemies';
    RangeLimit = 0;
    SpellType = 'StatusEffect';
    TintColor = make_color_rgb(255,102,102);
    FlashColor = make_color_rgb(255,0,0);
    SpellAIType = 'StatusEffectMagic';
    
    switch(Level){
    case 1:
        //Damage = 0;
        Range = 1;
        Area = 2;
        ManaCost = 3;
        DefenseDebuffStrength = 3;
        AgilityDebuffStrength = 3;
    break;
    case 2:
        //Damage = 0;
        Range = 2;
        Area = 3;
        ManaCost = 6;
        DefenseDebuffStrength = 3;
        AgilityDebuffStrength = 3;
    break;
    }
break;
//========
//=Muddle=
//========
case 'Muddle':
    Sprite = MuddleIconSprite;
    Target = 'Enemies';
    SelectType = 'Enemies';
    RangeLimit = 0;
    SpellType = 'StatusEffect';
    TintColor = make_color_rgb(255,102,102);
    FlashColor = make_color_rgb(255,0,0);
    SpellAIType = 'StatusEffectMagic';
    MuddleChance = .25;
    
    switch(Level){
    case 1:
        Range = 1;
        Area = 2;
        ManaCost = 3;
        HitChanceDebuffStrength = .5;
    break;
    case 2:
        Range = 2;
        Area = 3;
        ManaCost = 6;
        HitChanceDebuffStrength = .5;
        MuddleChance = 1;
        Confusion = true;
    break;
    }
break;
//=======
//=Detox=
//=======
case 'Detox':
    Sprite = DetoxIconSprite;
    RangeLimit = -1;
    Target = 'Allies';
    SelectType = 'Allies';
    CurePoison = true;
    SpellType = 'Heal';
    FlashColor = make_color_rgb(222,182,222);
    SpellAIType = 'HealMagic';
    TargetOther = true;
    
    switch(Level){
    case 1:
        Range = 1;
        Area = 1;
        ManaCost = 3;
    break;
    case 2:
        Range = 2;
        Area = 1;
        ManaCost = 6;
    break;
    case 3:
        Range = 2;
        Area = 1;
        ManaCost = 10;
    break;
    case 4:
        Range = 3;
        Area = 3;
        ManaCost = 16;
    break;
    }
break;

//============
//=Minor Heal=
//============
case 'Minor Heal':
    RangeLimit = -1;
    Target = 'Allies';
    SelectType = 'Allies';
    SpellType = 'Heal';
    HealDamage = 10;
    Range = 1;
    Area = 1;
    SpellAIType = 'HealMagic';
break;
//=============
//=Middle Heal=
//=============
case 'Middle Heal':
    RangeLimit = -1;
    Target = 'Allies';
    SelectType = 'Allies';
    SpellType = 'Heal';
    HealDamage = 20;
    Range = 1;
    Area = 1;
    SpellAIType = 'HealMagic';
break;
//============
//=Major Heal=
//============
case 'Major Heal':
    RangeLimit = -1;
    Target = 'Allies';
    SelectType = 'Allies';
    SpellType = 'Heal';
    HealDamage = 30;
    Range = 1;
    Area = 1;
    SpellAIType = 'HealMagic';
break;
//===========
//=Full Heal=
//===========
case 'Full Heal':
    RangeLimit = -1;
    Target = 'Allies';
    SelectType = 'Allies';
    SpellType = 'Heal';
    HealDamage = 1000;
    Range = 1;
    Area = 1;
    SpellAIType = 'HealMagic';
break;

//==============
//=Mana Restore=
//==============
case 'Mana Restore':
    switch(Level){
    case 1:
        RangeLimit = -1;
        Target = 'Allies';
        SelectType = 'Allies';
        SpellType = 'Heal';
        //Damage = 0;
        Range = 1;
        Area = 1;
        ManaRestore = 20;
        SpellAIType = 'HealMagic';
    break;
    case 4:
        TargetAllAllies = true;
        RangeLimit = -1;
        Target = 'Allies';
        SelectType = 'Allies';
        SpellType = 'Heal';
        //Damage = 0;
        Range = -1;
        Area = 1;
        ManaRestore = 1000;
        SpellAIType = 'HealMagic';
    break;
    }
break;

//========
//=Escape=
//========
case 'Escape':
    Sprite = EscapeIconSprite;
    RangeLimit = -1;
    Target = 'Allies';
    SelectType = 'Allies';
    SpellType = 'Heal';
    //Damage = 0;
    Range = 0;
    Area = 1;
    ManaCost = 8;
    SpellAIType = 'HealMagic';
break;

//=======
//=Debug=
//=======
case 'Quake':
    Sprite = BoltIconSprite;
    RangeLimit = -1;
    Target = 'Enemies';
    SelectType = 'Allies';
    SpellType = 'Damage';
    FlashColor = make_color_rgb(181,219,255);
    SpellAIType = 'DamageMagic';
    Range = 0;
    Area = 3;
    ManaCost = 1;
    LightningDamage = 14;
    SpellAIType = 'DamageMagic';
break;
case 'Summon':
    Sprite = BlastIconSprite;
    RangeLimit = 0;
    Target = 'EmptyTile';
    SelectType = 'EmptyTile';
    SpellType = 'Summon';
    FlashColor = make_color_rgb(181,219,255);
    SpellAIType = 'SummonMagic';
    
    switch(Level){
    case 1:
        Range = 2;
        Area = 1;
        ManaCost = 1;
        break;
    case 2:
        Range = 3;
        Area = 2;
        ManaCost = 2;
        break;
    }
    //LightningDamage = 14;
    //SpellAIType = 'SuMagic';
break;
//========
//=Recall=
//========
case 'Recall':
    Sprite = EscapeIconSprite;
    RangeLimit = -1;
    Target = 'Allies';
    SelectType = 'Allies';
    SpellType = 'Heal';
    Range = 0;
    Area = 1;
    ManaCost = 0;
    SpellAIType = 'HealMagic';
break;
}

//Blast Tint
//FlashColor = make_color_rgb(33,219,222);
/*
else{
    Sprite = BlankSpellSlotSprite;
    Damage = 0;
    Range = 0;
    Area = 1;
    ManaCost = 0;
    Target = 2;
    RangeLimit = 0;
}*/

switch(Return){
    case "Sprite": return Sprite; break;
    case "SpellRange": return Range; break;
    case "Area": return Area; break;
    case "ManaCost": return ManaCost; break;
    case "TargetType": return Target; break;
    case "SelectType": return SelectType; break;
    
    case "SpellLimit": return RangeLimit; break;
    case "SpellType": return SpellType; break;
    case "CurePoison": return CurePoison; break;
    case "TintColor": return TintColor; break;
    case "FlashColor": return FlashColor; break;
    case "ManaRestore": return ManaRestore; break;
    case "TargetAllAllies": return TargetAllAllies; break;
    case "TargetAllEnemies": return TargetAllEnemies; break;
    case "TargetAllUnits": return TargetAllUnits; break;
    case "SpellAIType": return SpellAIType; break;
    case "SleepChance": return SleepChance; break;
    case "SilenceChance": return SilenceChance; break;
    case "PoisonChance": return PoisonChance; break;
    case "PoisonPotency": return PoisonPotency; break;
    case "AttackBuffStrength": return AttackBuffStrength; break;
    case "DefenseBuffStrength": return DefenseBuffStrength; break;
    case "AgilityBuffStrength": return AgilityBuffStrength; break;
    case "AttackDebuffStrength": return AttackDebuffStrength; break;
    case "DefenseDebuffStrength": return DefenseDebuffStrength; break;
    case "AgilityDebuffStrength": return AgilityDebuffStrength; break;
    
    case "MuddleChance": return MuddleChance; break;
    case "HitChanceDebuffStrength": return HitChanceDebuffStrength; break;
    case "Confusion": return Confusion; break;
    
    case "HealDamage": return HealDamage; break;
    case "FireDamage": return FireDamage; break;
    case "IceDamage": return IceDamage; break;
    case "WindDamage": return WindDamage; break;
    case "EarthDamage": return EarthDamage; break;
    case "LightningDamage": return LightningDamage; break;
    case "LightDamage": return LightDamage; break;
    case "DarknessDamage": return DarknessDamage; break;
    case "VoidDamage": return VoidDamage; break;
    
    case "Uncurse": return Uncurse; break;
    case "Shield": return Shield; break;
    case "TargetOther": return TargetOther; break;
}










